local M = {}

local helper = require('scenario/scenariohelper')
local reset = true

local function onScenarioChange(scenario)
	if scenario.state == 'pre-start' then
		reset = true
	end
end

local function onBeamNGTrigger(data)
	if data.triggerName == 'portal1A' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "34.8399 39.6131 33.4432";
		]])
	elseif data.triggerName == 'portal1B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-27.7323 41.1336 33.7065";
		]])
	elseif data.triggerName == 'portal2A' then
		helper.flashUiMessage('Teleported!', 2)
		if data.subjectName == 'scenario_player0' then
			TorqueScript.eval([[
				scenario_player0.position = "-56.1782 -39.541 32.7061";
			]])
		elseif data.subjectName == 'key_box_1' then
			TorqueScript.eval([[
				key_box_1.position = "-56.1782 -30.541 32.7061";
			]])
		end
	elseif data.triggerName == 'portal2B' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			scenario_player0.position = "-27.1826 8.45708 0.144189";
		]])
	elseif data.triggerName == 'portal3' then
		helper.flashUiMessage('Teleported!', 2)
		TorqueScript.eval([[
			key_box_1.position = "74.5862 30.6997 17.4541";
		]])
	elseif data.triggerName == 'box' then
		helper.flashUiMessage('Wall Opened!', 3)
		TorqueScript.eval([[
			wall1.position = "10000 0 0";
			key_box_1.position = "10000 0 0";
		]])
		be:reloadStaticCollision();
	end
end

local function onPreRender(dt)
	if reset then
		TorqueScript.eval([[
			scenario_player0.position = "-12.486 -39.9743 0.184686";
			scenario_player0.rotation = "0 0 1 180";
			key_box_1.position = "-6.45105 -1.89636 7.28944";
			key_box_1.rotation = "1 0 0 0";
		]])
		reset = false
	end
end

M.onBeamNGTrigger = onBeamNGTrigger
M.onScenarioChange = onScenarioChange
M.onPreRender = onPreRender
return M